class QextMdiChildFrm

# class QextMdiChildFrm | Internal class. It's an MDI child frame widget. It contains a view widget and a frame caption. Usually you derive from its view. More...
Definition | `#include <include/qextmdichildfrm.h>`
Inherits | QFrame [public ]
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- enum MdiWindowState { Normal,Maximized,Minimized }

#### Public Methods

- QextMdiChildFrm (QextMdiChildArea *parent)
- ~QextMdiChildFrm ()
- void setClient (QextMdiChildView *w)
- void unsetClient ( QPoint positionOffset = QPoint(0,0))
- void setIcon (const QPixmap &pxm)
- QPixmap* icon ()
- void enableClose (bool bEnable)
- void setCaption (const QString& text)
- const QString& caption ()
- void setState (MdiWindowState state,bool bAnimate=TRUE)
- inline MdiWindowState state ()
- QRect mdiAreaContentsRect () const
- QRect restoreGeometry () const
- void setRestoreGeometry (const QRect& newRestGeo)
- void updateRects ()
- QPopupMenu* systemMenu ()
- inline int captionHeight ()
- void redecorateButtons ()
- bool isInDrag () const
- bool isInResize () const
- void raiseAndActivate ()
- virtual void setMinimumSize ( int minw, int minh )

#### Public Slots

- void slot_resizeViaSystemMenu ()

#### Public Members

- QextMdiChildView* m_pClient

#### Protected Methods

- virtual void resizeEvent (QResizeEvent *)
- virtual void mouseMoveEvent (QMouseEvent *e)
- virtual void mousePressEvent (QMouseEvent *e)
- virtual void mouseReleaseEvent (QMouseEvent *)
- virtual void moveEvent (QMoveEvent* me)
- virtual void leaveEvent (QEvent *)
- virtual bool eventFilter (QObject*, QEvent*)
- void resizeWindow (int resizeCorner, int x, int y)
- void setResizeCursor (int resizeCorner)
- void unsetResizeCursor ()
- virtual void switchToMinimizeLayout ()
- void linkChildren ( QDict* pFocPolDict)
- QDict* unlinkChildren ()
- int getResizeCorner (int ax,int ay)

#### Protected Slots

- void maximizePressed ()
- void restorePressed ()
- void minimizePressed ()
- void closePressed ()
- void undockPressed ()
- void showSystemMenu ()

#### Protected Members

- QextMdiChildArea* m_pManager
- QextMdiChildFrmCaption* m_pCaption
- QextMdiWin32IconButton* m_pWinIcon
- QToolButton* m_pUnixIcon
- QToolButton* m_pMinimize
- QToolButton* m_pMaximize
- QToolButton* m_pClose
- QToolButton* m_pUndock
- MdiWindowState m_state
- QRect m_restoredRect
- int m_iResizeCorner
- int m_iLastCursorCorner
- bool m_bResizing
- bool m_bDragging
- QPixmap* m_pIconButtonPixmap
- QPixmap* m_pMinButtonPixmap
- QPixmap* m_pMaxButtonPixmap
- QPixmap* m_pRestoreButtonPixmap
- QPixmap* m_pCloseButtonPixmap
- QPixmap* m_pUndockButtonPixmap
- int m_windowMenuID
- QPopupMenu* m_pSystemMenu
- QSize m_oldClientMinSize
- QSize m_oldClientMaxSize
- QLayout::ResizeMode m_oldLayoutResizeMode
- QTime m_timeMeasure

#### Private Members

- friend class QextMdiChildArea
- friend class QextMdiChildFrmCaption

## Detailed Description

friend class QextMdiChildArea | ### QextMdiChildArea

[private]

friend class QextMdiChildFrmCaption | ### QextMdiChildFrmCaption

[private]

enum MdiWindowState { Normal,Maximized,Minimized } | ### MdiWindowState

QextMdiChildView* m_pClient | ### m_pClient

QextMdiChildArea* m_pManager | ### m_pManager

[protected]

QextMdiChildFrmCaption* m_pCaption | ### m_pCaption

[protected]

QextMdiWin32IconButton* m_pWinIcon | ### m_pWinIcon

[protected]

QToolButton* m_pUnixIcon | ### m_pUnixIcon

[protected]

QToolButton* m_pMinimize | ### m_pMinimize

[protected]

QToolButton* m_pMaximize | ### m_pMaximize

[protected]

QToolButton* m_pClose | ### m_pClose

[protected]

QToolButton* m_pUndock | ### m_pUndock

[protected]

MdiWindowState m_state | ### m_state

[protected]

QRect m_restoredRect | ### m_restoredRect

[protected]

int m_iResizeCorner | ### m_iResizeCorner

[protected]

int m_iLastCursorCorner | ### m_iLastCursorCorner

[protected]

bool m_bResizing | ### m_bResizing

[protected]

bool m_bDragging | ### m_bDragging

[protected]

QPixmap* m_pIconButtonPixmap | ### m_pIconButtonPixmap

[protected]

QPixmap* m_pMinButtonPixmap | ### m_pMinButtonPixmap

[protected]

QPixmap* m_pMaxButtonPixmap | ### m_pMaxButtonPixmap

[protected]

QPixmap* m_pRestoreButtonPixmap | ### m_pRestoreButtonPixmap

[protected]

QPixmap* m_pCloseButtonPixmap | ### m_pCloseButtonPixmap

[protected]

QPixmap* m_pUndockButtonPixmap | ### m_pUndockButtonPixmap

[protected]

int m_windowMenuID | ### m_windowMenuID

[protected]

QPopupMenu* m_pSystemMenu | ### m_pSystemMenu

[protected]

QSize m_oldClientMinSize | ### m_oldClientMinSize

[protected]

QSize m_oldClientMaxSize | ### m_oldClientMaxSize

[protected]

QLayout::ResizeMode m_oldLayoutResizeMode | ### m_oldLayoutResizeMode

[protected]

QTime m_timeMeasure | ### m_timeMeasure

[protected]

QextMdiChildFrm (QextMdiChildArea *parent) | ### QextMdiChildFrm

Creates a new QextMdiChildFrm class.

~QextMdiChildFrm () | ### ~QextMdiChildFrm

Delicato : destroys this QextMdiChildFrm If a child is still here managed (no recreation was made) it is destroyed too.

void setClient (QextMdiChildView *w) | ### setClient

Reparents the widget w to this QextMdiChildFrm (if this is not already done) Installs an event filter to catch focus events. Resizes this mdi child in a way that the child fits perfectly in.

void unsetClient ( QPoint positionOffset = QPoint(0,0)) | ### unsetClient

Reparents the client widget to 0 (desktop), moves with an offset from the original position Removes the event filter.

void setIcon (const QPixmap &pxm) | ### setIcon

Sets the window icon pointer.

QPixmap* icon () | ### icon

Returns the child frame icon.

void enableClose (bool bEnable) | ### enableClose

Enables or disables the close button

void setCaption (const QString& text) | ### setCaption

Sets the caption of this window

const QString& caption () | ### caption

Returns the caption of this mdi child. Cool to have it inline...

void setState (MdiWindowState state,bool bAnimate=TRUE) | ### setState

Minimizes , Maximizes or restores the window.

inline MdiWindowState state () | ### state

Returns the current state of the window Cool to have it inline...

QRect mdiAreaContentsRect () | ### mdiAreaContentsRect

[const]

Returns the inner client area of the parent of this (which is QextMdiChildArea).

QRect restoreGeometry () | ### restoreGeometry

[const]

Returns the geometry that will be restored by calling restore().

void setRestoreGeometry (const QRect& newRestGeo) | ### setRestoreGeometry

Sets the geometry that will be restored by calling restore().

void updateRects () | ### updateRects

Forces updating the rects of the caption and so... It may be useful when setting the mdiCaptionFont of the MdiManager

QPopupMenu* systemMenu () | ### systemMenu

Returns the system menu.

inline int captionHeight () | ### captionHeight

Returns the caption bar height

void redecorateButtons () | ### redecorateButtons

sets new raise behaviour and pixmaps of the buttons depending on the current decoration style

bool isInDrag () | ### isInDrag

[const]

returns the mouse state "In Drag"

bool isInResize () | ### isInResize

[const]

returns the mouse state "In Resize"

void raiseAndActivate () | ### raiseAndActivate

Internally called from the signal focusInEventOccurs. It raises the MDI childframe to the top of all other MDI child frames and sets the focus on it.

void setMinimumSize ( int minw, int minh ) | ### setMinimumSize

[virtual]

Sets the minimum size of the widget to w by h pixels. It extends it's base clase method in a way that the minimum size of the child area will be set additionally if the view is maximized.

void slot_resizeViaSystemMenu () | ### slot_resizeViaSystemMenu

[slot]

void resizeEvent (QResizeEvent *) | ### resizeEvent

[protected virtual]

Reimplemented from its base class. Resizes the captionbar, relayouts the position of the system buttons, and calls resize for its embedded client QextMdiChildView with the proper size

void mouseMoveEvent (QMouseEvent *e) | ### mouseMoveEvent

[protected virtual]

Reimplemented from its base class. Detects if the mouse is on the edge of window and what resize cursor must be set. Calls QextMdiChildFrm::resizeWindow if it is in m_bResizing.

void mousePressEvent (QMouseEvent *e) | ### mousePressEvent

[protected virtual]

Reimplemented from its base class. Colours the caption, raises the childfrm widget and turns to resize mode if it is on the edge (resize-sensitive area)

void mouseReleaseEvent (QMouseEvent *) | ### mouseReleaseEvent

[protected virtual]

Reimplemented from its base class. Sets a normal cursor and leaves the resize mode.

void moveEvent (QMoveEvent* me) | ### moveEvent

[protected virtual]

Reimplemented from its base class. give its child view the chance to notify a childframe move... that's why it sends a QextMdiChildMovedEvent to the embedded QextMdiChildView .

void leaveEvent (QEvent *) | ### leaveEvent

[protected virtual]

Reimplemented from its base class. If not in resize mode, it sets the mouse cursor to normal appearance.

bool eventFilter (QObject*, QEvent*) | ### eventFilter

[protected virtual]

Reimplemented from its base class. Additionally it catches

- the client's mousebutton press events and raises and activates the childframe then
- the client's resize event and resizes its childframe widget (this) as well

void resizeWindow (int resizeCorner, int x, int y) | ### resizeWindow

[protected]

Calculates the new geometry from the new mouse position given as parameters and calls QextMdiChildFrm::setGeometry

void setResizeCursor (int resizeCorner) | ### setResizeCursor

[protected]

Override the cursor appearance depending on the widget corner given as parameter

void unsetResizeCursor () | ### unsetResizeCursor

[protected]

changes from the resize cursor to the normal (previous) cursor

void switchToMinimizeLayout () | ### switchToMinimizeLayout

[protected virtual]

That means to show a mini window showing the childframe's caption bar, only. It cannot be resized.

void maximizePressed () | ### maximizePressed

[protected slots slot]

Handles a click on the Maximize button

void restorePressed () | ### restorePressed

[protected slots slot]

Handles a click on the Restore (Normalize) button

void minimizePressed () | ### minimizePressed

[protected slots slot]

Handles a click on the Minimize button.

void closePressed () | ### closePressed

[protected slots slot]

Handles a click on the Close button.

void undockPressed () | ### undockPressed

[protected slots slot]

Handles a click on the Undock (Detach) button

void showSystemMenu () | ### showSystemMenu

[protected slots slot]

Shows a system menu for child frame windows.

void linkChildren ( QDict* pFocPolDict) | ### linkChildren

[protected]

Restore the focus policies for _all_ widgets in the view using the list given as parameter. Install the event filter for all direct child widgets of this. (See QextMdiChildFrm::eventFilter )

QDict* unlinkChildren () | ### unlinkChildren

[protected]

Backups all focus policies of _all_ child widgets in the MDI childview since they get lost during a reparent. Remove all event filters for all direct child widgets of this. (See QextMdiChildFrm::eventFilter )

int getResizeCorner (int ax,int ay) | ### getResizeCorner

[protected]

Calculates the corner id for the resize cursor. The return value can be tested for: QEXTMDI_RESIZE_LEFT, QEXTMDI_RESIZE_RIGHT, QEXTMDI_RESIZE_TOP, QEXTMDI_RESIZE_BOTTOM or an OR'd variant of them for the corners.

Generated by: falk on pc9 on Fri Nov 30 14:44:26 2001, using kdoc 2.0a53.